/****************************************************************************
 *
 * DBAComp(anion) - An administration tool for Oracle databases
 * Copyright (C) 2000-2003  Torsten FASSIAN (torsten@internet.lu) 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *	As a special exception, you have permission to link this program
 *	with the Qt library and distribute executables, as long as you
 *	follow the requirements of the GNU GPL in regard to all of the
 *	software in the executable aside from Qt.
 *
 ****************************************************************************/
#include "logondlg.h"
#include <qpushbutton.h>
#include <qsizepolicy.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include <iostream.h>
#include <qstringlist.h>

LogonDlg::LogonDlg(QWidget *parent, QString name, const QString& un, 
			const QString& pw, const QString& ta, 
			const QString& talist)
        : QDialog( parent, name.local8Bit(), TRUE )
{
        QLabel *ul = new QLabel(tr("Username:"), this);
        ul->setGeometry(10,40,90,20);
        username = new QLineEdit(this);
        username->setGeometry(100,40,200,20);
	username->setText(un);

        QLabel *pl = new QLabel(tr("Password:"), this);
        pl->setGeometry(10,70,90,20);
        password = new QLineEdit(this);
	password->setEchoMode(QLineEdit::Password);
        password->setGeometry(100,70,200,20);
	password->setText(pw);

        QLabel *tl = new QLabel(tr("TNS Alias:"), this);
        tl->setGeometry(10,100,90,20);
	tnsalias = new QComboBox( TRUE, this);
        tnsalias->setGeometry(100,100,200,20);
        tnsalias->setAutoCompletion(true);
	tnsalias->insertStringList(breakCommaDelimitedList(talist));
	//tnsalias->insertItem(ta,0);
	tnsalias->lineEdit()->setText(ta);

        QPushButton *ok, *cancel;
        ok = new QPushButton( "Connect", this );
        ok->setGeometry( 130,160, 80,30 );
        connect( ok, SIGNAL(clicked()), SLOT(accept()) );
        cancel = new QPushButton( "Cancel", this );
        cancel->setGeometry( 220,160, 80,30 );
        connect( cancel, SIGNAL(clicked()), SLOT(reject()) );

	ok->setDefault(true);

	setCaption("Connect");
	setFixedWidth(330);
	setFixedHeight(200);

	username->setFocus();
	username->selectAll();	
}

LogonDlg::~LogonDlg()
{
}

QStringList LogonDlg::breakCommaDelimitedList(const QString& cdList)
{
	int next_comma=cdList.find(",");
	int last_comma=-1;
	QStringList sl;
	while (next_comma!=-1)
	{
		QString entry=cdList.mid(last_comma+1, next_comma-last_comma-1);
		entry=entry.stripWhiteSpace();
		sl << entry;
		last_comma=next_comma;
		next_comma=cdList.find(",",last_comma+1);
	}
	sl << cdList.mid(last_comma+1, next_comma-last_comma-1);
	sl.sort();

	return sl;
}
	


const QString LogonDlg::getUsername() const
{
	return username->text();
}

const QString LogonDlg::getPassword() const
{
	return password->text();
}

const QString LogonDlg::getTNSAlias() const
{
	return tnsalias->currentText();
}

QSizePolicy LogonDlg::sizePolicy () const
{
	return QSizePolicy(QSizePolicy::Fixed,QSizePolicy::Fixed);
}
