/****************************************************************************
 *
 * DBAComp(anion) - An administration tool for Oracle databases
 * Copyright (C) 2000-2003  Torsten FASSIAN (torsten@internet.lu) 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *	As a special exception, you have permission to link this program
 *	with the Qt library and distribute executables, as long as you
 *	follow the requirements of the GNU GPL in regard to all of the
 *	software in the executable aside from Qt.
 *
 ****************************************************************************/

#ifndef QT_ORACONNECT_H
#define QT_ORACONNECT_H

#include <oraconnect.h>
#include <qstring.h>

////////////////////////////
class qt_oerr: public oerr
{
public:
	qt_oerr(const QString& msg);
	qt_oerr(const oerr& err);
	QString getMsg();
};

////////////////////////////
class qt_OraParm: public OraParm
{

public:
	qt_OraParm(const int num);
        qt_OraParm(const QString& parm=QString::null);
	qt_OraParm(const OraParm& parm);

        void addParm(const QString& parm);
        const QString getParm(int index) const;
        OraParm& operator= (const QString& parm);
};

///////////////////////////
class qt_oraconnect: public oraconnect
{
public:
	// Create oraconnect instance and connect to a database
	qt_oraconnect(const QString& name,     // logical name of the connection
		   const QString& uname=QString::null,  // username
                   const QString& pwd=QString::null,    // password
                   const QString& db=QString::null);    // tnsalias

	void open(const QString& query); // Open Cursor without bind parms
	void open(const QString& query, const OraParm& parm); // Open Cursor with
	QString getColName(int col); // return the name of cols in the query
	QString getCol(int col); // return the value of a column
};
#endif
