/****************************************************************************
 *
 * DBAComp(anion) - An administration tool for Oracle databases
 * Copyright (C) 2000-2003  Torsten FASSIAN (torsten@internet.lu) 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *	As a special exception, you have permission to link this program
 *	with the Qt library and distribute executables, as long as you
 *	follow the requirements of the GNU GPL in regard to all of the
 *	software in the executable aside from Qt.
 *
 ****************************************************************************/
#include "replacedlg.h"
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <iostream.h>
#include <qfiledialog.h>
#include <qmessagebox.h>


ReplaceDlg::ReplaceDlg(const QString& w, QWidget *parent, QString name)
        : QDialog( parent, name.local8Bit(), TRUE ),
		word(0),newword(0),direction(0),action(QString::null)
{
        QLabel *l = new QLabel("Find what:", this);
        l->setGeometry(10,40,90,20);
        word = new QLineEdit(this);
        word->setGeometry(100,40,200,20);

        l = new QLabel("Replace by:", this);
        l->setGeometry(10,60,90,20);
        newword = new QLineEdit(this);
        newword->setGeometry(100,60,200,20);

        direction = new QButtonGroup(this);
       	direction->setGeometry(100,90,200,60);
	QRadioButton * rb = new QRadioButton("Down",direction);
	rb->setChecked(TRUE);
	rb->setGeometry(10,10,160,20);
	rb = new QRadioButton("Up",direction);
	rb->setGeometry(10,30,160,20);

        QPushButton *find, *cancel, *replace, *replaceall;

        find = new QPushButton( "Find", this );
        find->setGeometry( 10,180, 80,30 );
        //connect( find, SIGNAL(clicked()), SLOT(setAction("FIND")) );
        connect( find, SIGNAL(clicked()), SLOT(setFindAction()) );

        replace = new QPushButton( "Replace", this );
        replace->setGeometry( 95,180, 80,30 );
        connect( replace, SIGNAL(clicked()), SLOT(setReplaceAction()));

        replaceall = new QPushButton( "Replace all", this );
        replaceall->setGeometry( 180,180, 80,30 );
        connect( replaceall, SIGNAL(clicked()), SLOT(setReplaceAllAction()));


        cancel = new QPushButton( "Cancel", this );
        cancel->setGeometry( 265,180, 80,30 );
        connect( cancel, SIGNAL(clicked()), SLOT(reject()) );

        find->setDefault(true);

	word->setFocus();
	setCaption("Replace");
	setFixedWidth(350);
	setFixedHeight(220);
}

ReplaceDlg::~ReplaceDlg()
{
#ifdef DESTRACE
	cerr << "ReplaceDlg destructor" << endl;
#endif
}

const QString ReplaceDlg::getWord() const
{
	return word->text();
}

const QString ReplaceDlg::getNewWord() const
{
	return newword->text();
}

bool ReplaceDlg::getUp() const
{
	if (direction->id(direction->selected())==0)
		return true;
	else
		return false;
}

QString ReplaceDlg::getAction() const
{
	return action;
}

void ReplaceDlg::setFindAction()
{
	 action="FIND";
	 accept();
}

void ReplaceDlg::setReplaceAction()
{
	 action="REPLACE";
	 accept();
}

void ReplaceDlg::setReplaceAllAction()
{
	 action="REPLACE ALL";
	 accept();
}
