/****************************************************************************
 *
 * DBAComp(anion) - An administration tool for Oracle databases
 * Copyright (C) 2000-2003  Torsten FASSIAN (torsten@internet.lu) 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *	As a special exception, you have permission to link this program
 *	with the Qt library and distribute executables, as long as you
 *	follow the requirements of the GNU GPL in regard to all of the
 *	software in the executable aside from Qt.
 *
 ****************************************************************************/
#include <iostream.h>
#include "row.h"
#include "w_dba_segments.h"
#include "w_dba_segments_info.h"

w_dba_segments::w_dba_segments()
	: DBList("dba_segments",0,"DBA_SEGMENTS")
{
	show();
}

w_dba_segments::w_dba_segments(const ObjParm& parm)
	: DBList(parm,"dba_segments_per_user",0,"DBA_SEGMENTS for user "+parm.getParm(0))
{
        //setCaption("DBA_SEGMENTS for user "+parm.getParm(0));
	show();
}

void w_dba_segments::callInfo(row * clickedRow)
{
	ObjParm parm;
        if (getWinParm())
        { // We are in the per_user case
		parm.addParm(getWinParm()->getParm(0)); // username
        }
        else
        { // We are in the all objects case
                parm.addParm(clickedRow->getCellbyName("owner"));
        }
	parm.addParm(clickedRow->getCellbyName("segment_name"));
	w_dba_segments_info *w = new w_dba_segments_info(parm);
}
