/****************************************************************************
 *
 * DBAComp(anion) - An administration tool for Oracle databases
 * Copyright (C) 2000-2003  Torsten FASSIAN (torsten@internet.lu) 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *	As a special exception, you have permission to link this program
 *	with the Qt library and distribute executables, as long as you
 *	follow the requirements of the GNU GPL in regard to all of the
 *	software in the executable aside from Qt.
 *
 ****************************************************************************/
#include <iostream.h>
#include <qlabel.h>
#include "scrollview.h"
//#include "mdi.h"
#include <qfont.h>
#include "qt_oraconnect.h"
#include <qmessagebox.h>
#include "griddatadisplay.h"
#include "w_performance.h"
#include "sqlcache.h"
#include <qobjcoll.h>
#include <qtoolbutton.h>                                                                                          

w_performance::w_performance()
	: DBTab(0,"Performance indicators")
{
	//setCaption("Performance indicators");
	makeTabs();
        show();
        // from now on changing to the space tab should fill it
        // THis connect must be here. If you put it earlier, the fill code
        // will be executed already during window creation making this much slower
// NO LONGER NECESSARY AS RETRIEVE IS REIMPLEMENTED
//        connect((TabDataDisplay*)getDD(), SIGNAL(selected(const QString &)), this, SLOT(fillOtherTab(const QString & )));
}

void w_performance::makeTabs()
{
	addGridTab("sort_stats","Sorts");
	makeOtherTab();
}

void w_performance::makeOtherTab()
{
        const int startx=10;
        const int starty=10;
        const int lw=300;
        const int lh=20;
        const int fw=90;
        const int fh=20;
	const int vw=100;
	const int vh=20;
        const int hor_dist=10;
        const int ver_dist=0;

        OtherTab=new ScrollView(this);
        OtherTab->resizeContents(530,335);
        //OtherTab->resizeContents(530,289);
        OtherTab->setVScrollBarMode(QScrollView::Auto);
        OtherTab->setHScrollBarMode(QScrollView::Auto);
	OtherTab->enableClipper(TRUE);

	OtherTab->viewport()->setBackgroundMode(PaletteBase);

    	connect(OtherTab, SIGNAL(shown()), this, SLOT(OtherTabShown()));
    	connect(OtherTab, SIGNAL(hidden()), this, SLOT(OtherTabHidden()));                                            
	connect(OtherTab, SIGNAL(rightButtonPressed(const QPoint &)), this, 
		SLOT(ContextMenu(const QPoint &)));        

        QLabel * l = new QLabel("Important ratios",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+0*(lh+ver_dist));
	QFont curr_font=l->font();
	curr_font.setBold(true);
	curr_font.setUnderline(true);
	l->setFont(curr_font);

        l = new QLabel("Ref. values",OtherTab->viewport());
        l->resize(vw,vh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx+lw+hor_dist+fw+hor_dist,starty+0*(lh+ver_dist));
	l->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        curr_font=l->font();
        curr_font.setBold(true);
        curr_font.setUnderline(true);
        l->setFont(curr_font);


	// dd cache
        l = new QLabel("Data dictionary cache (row cache) miss ratio (%):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+1*(lh+ver_dist));

        QLabel * f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+1*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
	dd_cache=f;

	QLabel * v = new QLabel("<10-15%",OtherTab->viewport());
	v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
	OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+1*(fh+ver_dist));
	v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);

	
	// lib cache
        l = new QLabel("Library cache (Shared SQL) miss ratio (%):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+2*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+2*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        lib_cache=f;

        v = new QLabel("<1%",OtherTab->viewport());
        v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
        OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+2*(fh+ver_dist));
        v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);

        // buf cache
        l = new QLabel("Data buffer cache hit ratio (%):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+3*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+3*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        buf_cache=f;

        v = new QLabel(">60-70%",OtherTab->viewport());
        v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
        OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+3*(fh+ver_dist));
        v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);

        // redo log contention
        l = new QLabel("Redo log contention:",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+4*(lh+ver_dist));
        curr_font=l->font();
        curr_font.setBold(true);
        curr_font.setUnderline(true);
        l->setFont(curr_font);

	l = new QLabel("Redo log space requests:",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+5*(lh+ver_dist));
 
        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+5*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        redo=f;

        v = new QLabel("close to 0",OtherTab->viewport());
        v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
        OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+5*(fh+ver_dist));
        v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
 

        // rbs contention
        l = new QLabel("RBS contention:",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+6*(lh+ver_dist));
        curr_font=l->font();
        curr_font.setBold(true);
        curr_font.setUnderline(true);
        l->setFont(curr_font);

	// system undo header waits
        l = new QLabel("System undo header waits (%):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+7*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+7*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        rbs_sys_head_waits=f;

        v = new QLabel("<1%",OtherTab->viewport());
        v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
        OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+7*(fh+ver_dist));
        v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);

        // system undo block waits
        l = new QLabel("System undo block waits (%):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+8*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+8*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        rbs_sys_block_waits=f;

        v = new QLabel("<1%",OtherTab->viewport());
        v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
        OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+8*(fh+ver_dist));
        v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);

        // undo header waits
        l = new QLabel("Undo header waits (%):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+9*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+9*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        rbs_head_waits=f;

        v = new QLabel("<1%",OtherTab->viewport());
        v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
        OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+9*(fh+ver_dist));
        v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);

        // undo block waits
        l = new QLabel("Undo block waits (%):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+10*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+10*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        rbs_block_waits=f;

        v = new QLabel("<1%",OtherTab->viewport());
        v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
        OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+10*(fh+ver_dist));
        v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);

        // total rbs waits
        l = new QLabel("Total RBS waits (%):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+11*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+11*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        total_rbs_waits=f;

        v = new QLabel("<1-2%",OtherTab->viewport());
        v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
        OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+11*(fh+ver_dist));
        v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);

        // mts contention
        l = new QLabel("MTS contention:",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+12*(lh+ver_dist));
        curr_font=l->font();
        curr_font.setBold(true);
        curr_font.setUnderline(true);
        l->setFont(curr_font);

        // dispatcher busy rate
        l = new QLabel("Busy rate for dispatchers (%):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+13*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+13*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        mts_busy_rate=f;

        v = new QLabel("<50%",OtherTab->viewport());
        v->resize(vw,vh);
	v->setBackgroundMode(PaletteBase);
        OtherTab->addChild(v,startx+lw+hor_dist+fw+hor_dist,starty+13*(fh+ver_dist));
        v->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);

        // dispatcher response queues waits (1/100s)
        l = new QLabel("Dispatcher response queues waits (1/100s):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+14*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+14*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        mts_disp_waits=f;

        // server request queue waits (1/100s)
        l = new QLabel("Server request queue waits (1/100s):",OtherTab->viewport());
        l->resize(lw,lh);
	l->setBackgroundMode(PaletteBase);
        OtherTab->addChild(l,startx,starty+15*(lh+ver_dist));

        f = new QLabel("",OtherTab->viewport());
        f->resize(fw,fh);
	f->setBackgroundMode(PaletteBase);
        OtherTab->addChild(f,startx+lw+hor_dist,starty+15*(fh+ver_dist));
        f->setAlignment(QFrame::AlignRight|QFrame::AlignVCenter);
        f->setFrameStyle(QFrame::Box|QFrame::Plain);
        mts_server_waits=f;

	addTab(OtherTab,"Other");
}

void w_performance::fillOtherTab(const QString & tabname)
{
        if (tabname=="Other")
        {
           if (!gSQLCache)
           {
           	QMessageBox::critical( 0, "SQL cache error", QString("The SQL cache is not set up"),QMessageBox::Ok | QMessageBox::Default,0,0);
              	return;
           }                                                                                                         
    	   if (!gConnObj) 
    	   {
		QMessageBox::critical( 0, "Database error", "You are not connected to a database!",QMessageBox::Ok | QMessageBox::Default,0,0);   
		return;
	   }

	   qApp->setOverrideCursor(waitCursor);
           try
           {
		// dd cache
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("ddcache_ratio"));
                gConnObj->fetch();
                dd_cache->setText(gConnObj->getCol(0));
                gConnObj->close();

                // lib cache
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("libcache_ratio"));
                gConnObj->fetch();
                lib_cache->setText(gConnObj->getCol(0));
                gConnObj->close();

                // buf cache
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("db_block_gets"));
                gConnObj->fetch();
		float db_block_gets=((QString)(gConnObj->getCol(0))).toFloat();
                gConnObj->close();
                gConnObj->open(gSQLCache->getSQL("consistent_gets"));
                gConnObj->fetch();
                float consistent_gets=((QString)(gConnObj->getCol(0))).toFloat();
                gConnObj->close();
                gConnObj->open(gSQLCache->getSQL("phys_reads"));
                gConnObj->fetch();
                float phys_reads=((QString)(gConnObj->getCol(0))).toFloat();
                gConnObj->close();
		float buf_cache_ratio=(1-(phys_reads/(db_block_gets+consistent_gets)))*100;
		QString str_buf_cache_ratio;
		str_buf_cache_ratio.setNum(buf_cache_ratio,'g',4);
                buf_cache->setText(str_buf_cache_ratio);

		// redol og space requests
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("redo_log_space_req"));
                gConnObj->fetch();
                redo->setText(gConnObj->getCol(0));
                gConnObj->close();

                // system undo header waits
	        // Prepare the Oracle parameter
                qt_OraParm op(2);
		QString str_consistent_gets, str_db_block_gets;
		str_consistent_gets.setNum(consistent_gets);
		str_db_block_gets.setNum(db_block_gets);
                op.addParm(str_consistent_gets);
                op.addParm(str_db_block_gets);

                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("sys_rbs_header"),op);
                gConnObj->fetch();
                rbs_sys_head_waits->setText(gConnObj->getCol(0));
                gConnObj->close();

                // system undo block waits
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("sys_rbs_block"),op);
                gConnObj->fetch();
                rbs_sys_block_waits->setText(gConnObj->getCol(0));
                gConnObj->close();

                // undo header waits
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("rbs_header"),op);
                gConnObj->fetch();
                rbs_head_waits->setText(gConnObj->getCol(0));
                gConnObj->close();

                // undo block waits
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("rbs_block"),op);
                gConnObj->fetch();
                rbs_block_waits->setText(gConnObj->getCol(0));
                gConnObj->close();

                // total rbs waits
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("total_rbs_waits"));
                gConnObj->fetch();
                total_rbs_waits->setText(gConnObj->getCol(0));
                gConnObj->close();

                // busy rate for dispatchers
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("disp_busy"));
                gConnObj->fetch();
                mts_busy_rate->setText(gConnObj->getCol(0));
                gConnObj->close();

                // dispatcher response queue waits
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("disp_resp_waits"));
                gConnObj->fetch();
                mts_disp_waits->setText(gConnObj->getCol(0));
                gConnObj->close();

                // server request queue waits
                // Execute sql from the cache file
                gConnObj->open(gSQLCache->getSQL("server_waits"));
                gConnObj->fetch();
                mts_server_waits->setText(gConnObj->getCol(0));
                gConnObj->close();
           }
           catch (oerr & e)
           {
	   	qApp->restoreOverrideCursor();
                QMessageBox::critical( 0, "Database error", ((qt_oerr&)e).getMsg(),QMessageBox::Ok | QMessageBox::Default,0,0);
                return;
           }
	   qApp->restoreOverrideCursor();
        }
}
 
void w_performance::OtherTabShown()
{
    QPopupMenu * action_menu = getActionMenu();
    action_menu->setItemEnabled(action_menu->idAt(6),false);
    action_menu->setItemEnabled(action_menu->idAt(7),false);
    action_menu->setItemEnabled(action_menu->idAt(8),false);
    action_menu->setItemEnabled(action_menu->idAt(9),false);
    action_menu->setItemEnabled(action_menu->idAt(10),false);

	QObjectList *list = ((QObject *)getActionToolBar())->queryList("QToolButton");
    QObjectListIt it( *list );          // iterate over the buttons
    QObject * obj;
    while ( (obj=it.current()) != 0 ) 
	{ // for each found object...
       	//if (((QString)((QToolButton *)obj)->name())=="Save as"
       	if (((QString)((QToolButton *)obj)->name())=="Sort"
		||  ((QString)((QToolButton *)obj)->name())=="Filter"
		||  ((QString)((QToolButton *)obj)->name())=="SQL")
		{
			((QToolButton *)obj)->setEnabled(false);
		}
        ++it;
    }                                                                           
}


void w_performance::OtherTabHidden()
{
    QPopupMenu * action_menu = getActionMenu();
    action_menu->setItemEnabled(action_menu->idAt(6),true);
    action_menu->setItemEnabled(action_menu->idAt(7),true);
    action_menu->setItemEnabled(action_menu->idAt(8),true);
    action_menu->setItemEnabled(action_menu->idAt(9),true);
    action_menu->setItemEnabled(action_menu->idAt(10),true);

	QObjectList *list = ((QObject *)getActionToolBar())->queryList("QToolButton");
    QObjectListIt it( *list );          // iterate over the buttons
    QObject * obj;
    while ( (obj=it.current()) != 0 ) 
	{ // for each found object...
       	//if (((QString)((QToolButton *)obj)->name())=="Save as"
       	if (((QString)((QToolButton *)obj)->name())=="Sort"
		||  ((QString)((QToolButton *)obj)->name())=="Filter"
		||  ((QString)((QToolButton *)obj)->name())=="SQL")
		{
			((QToolButton *)obj)->setEnabled(true);
		}
        ++it;
    }                                                                           
}

void w_performance::retrieve()
{
	QString tabname=((TabDataDisplay *)getDD())->getCurrentTab();
	if (tabname!="Other")
	{
		DBSheet::retrieve();
	}
	else
	{
		fillOtherTab(tabname);
	}
}

void w_performance::Print()
{
        QString tabname=((TabDataDisplay *)getDD())->getCurrentTab();
        if (tabname!="Other")
        {
                DBSheet::Print();
        }
        else
        {
               OtherTab->printData(); 
        }
}

void w_performance::SaveAs()
{
        QString tabname=((TabDataDisplay *)getDD())->getCurrentTab();
        if (tabname!="Other")
        {
                DBSheet::SaveAs();
        }
        else
        {
               OtherTab->saveData();
        }
}
