/****************************************************************************
 *
 * DBAComp(anion) - An administration tool for Oracle databases
 * Copyright (C) 2000-2003  Torsten FASSIAN (torsten@internet.lu) 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *	As a special exception, you have permission to link this program
 *	with the Qt library and distribute executables, as long as you
 *	follow the requirements of the GNU GPL in regard to all of the
 *	software in the executable aside from Qt.
 *
 ****************************************************************************/
#include <iostream.h>
#include "griddatadisplay.h"
#include "w_v_session_info.h"

w_v_session_info::w_v_session_info(const ObjParm& parm, const QString username)
	: DBTab(parm,0,"Session information for SID "+parm.getParm(0)+" ("+username+")")
{
	//setCaption("Session information for SID "+parm.getParm(0)+" ("+username+")");
	makeTabs();
        show();
}

void w_v_session_info::makeTabs()
{
	addGridTab("v_process_per_session","Process");
	addGridTab("v_sesstat_per_session","Stats");
	addGridTab("v_open_cursor_per_session","Cursors");
	addFormTab("v_sess_io_per_session","I/O",1,130,130);
	addGridTab("v_session_wait_per_session","Waits");
	addGridTab("v_session_connect_info_per_session","Connect info");
	addFormTab("v_transaction_per_session","Transactions",2,130,130);
	addFormTab("cur_sql_per_session","Curr SQL",2,130,130,"sql_text",400,150);
	addFormTab("prev_sql_per_session","Prev SQL",2,130,130,"sql_text",400,150);
	addGridTab("v_session_event_per_session","Events");
	addGridTab("v_access_per_session","Access");
}
